package binclock;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;

import java.net.*;

public class AppletBC extends Applet implements Runnable
{
  private boolean isStandalone = false;
  //Get a parameter value
  public String getParameter(String key, String def)
  {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public AppletBC()
  {
  }
  //Initialize the applet
  public void init()
  {
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception
  {
  }

  private void DrawDigit( Graphics oGraphics, Dimension oDPt, int iIdx, int iVal )
  {
   int iI, iB = 1, iX, iY;

   for( iI = 0; iI < 4; iI ++ )
   {
    iX = iIdx*oDPt.width;
    iY = (1+3-iI)*oDPt.height;
    if( ( iVal & iB ) == iB )
    {
     if( fAllGph )
      oGraphics.drawImage( oImageBGon, iX, iY, oDPt.width, oDPt.height, null );
     else
     {
      oGraphics.setColor( Color.gray );
      oGraphics.fillRoundRect( iX, iY, oDPt.width, oDPt.height, oDPt.width, oDPt.height );
     }
    }
    else
    {
     if( fAllGph )
      oGraphics.drawImage( oImageBGof, iX, iY, oDPt.width, oDPt.height, null );
     else
     {
      oGraphics.setColor( Color.lightGray );
      oGraphics.fillRoundRect( iX, iY, oDPt.width, oDPt.height, oDPt.width, oDPt.height );
     }
    }
    iB = iB << 1;
   }
  }

  private void DrawDigits( Graphics oGraphics, Dimension oDPt, int iIdx, int iVal )
  {
   iIdx = iIdx * 3;
   DrawDigit( oGraphics, oDPt, iIdx-1, (iVal%10 )    );
   DrawDigit( oGraphics, oDPt, iIdx-2, (iVal%100)/10 );
  }

  public void paint( Graphics oGph )
  {
   Calendar oCalendar = Calendar.getInstance( );

    if( fAllGph )
     oGraphics.drawImage( oImageBG, 0, 0, oDim.width, oDim.height, null );
    else
    {
     oGraphics.setColor( Color.white );
     oGraphics.fillRect( 0, 0, oDim.width, oDim.height );
    }

    DrawDigits( oGraphics, oDPt, 1, oCalendar.get( Calendar.HOUR_OF_DAY ) );
    DrawDigits( oGraphics, oDPt, 2, oCalendar.get( Calendar.MINUTE ) );
    DrawDigits( oGraphics, oDPt, 3, oCalendar.get( Calendar.SECOND ) );
 
    oGph.drawImage( oImage, 0, 0, null );
  }

  Dimension oDim, oDPt;
  Image oImage;
  Image oImageBG, oImageBGon, oImageBGof;
  Graphics oGraphics;
  boolean fAllGph = false;
  //Start the applet
  public void start()
  {
    MediaTracker oMT;
    oMT = new MediaTracker( this );
    oDPt = new Dimension( );


    oDim = getSize( );
    oDPt.width  = oDim.width/10;
    oDPt.height = oDim.height/6;

    oImage = createImage( oDim.width, oDim.height );
    oGraphics = oImage.getGraphics( );
    oImageBG   = getImage( getCodeBase( ), "binclock/gif/bg.gif" );
    oImageBGon = getImage( getCodeBase( ), "binclock/gif/bgon.gif" );
    oImageBGof = getImage( getCodeBase( ), "binclock/gif/bgof.gif" );

    oMT.addImage( oImageBG, 1 );
    oMT.addImage( oImageBGon, 2 );
    oMT.addImage( oImageBGof, 3 );
    try{
         oMT.waitForAll( );
         
    }catch( Exception ex ){;}

    if( oMT.statusAll( false ) == MediaTracker.COMPLETE )
     fAllGph = true;

    //oGraphics.drawImage( oImageBG, 0, 0, oDim.width, oDim.height, null );

    m_JMult = new Thread(this);
    m_JMult.start();
  }

  private Thread m_JMult = null;
  public void run()
  {
   while( true )
   {
    try{
        Thread.sleep( 500 );
       }
       catch(Exception ex) {;}

    paint( getGraphics( ) );

   }
  }

  //Stop the applet
  public void stop()
  {
   if( m_JMult != null )
       m_JMult.stop( );
  }
  //Destroy the applet
  public void destroy()
  {
  }
  //Get Applet information
  public String getAppletInfo()
  {
    return "Applet Information";
  }
  //Get parameter info
  public String[][] getParameterInfo()
  {
    return null;
  }
  /*
  //Main method
  public static void main(String[] args)
  {
    AppletBC applet = new AppletBC();
    applet.isStandalone = true;
    Frame frame;
    frame = new Frame();
    frame.setTitle("Applet Frame");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(400,320);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }*/
}